/**
 ******************************************************************************
 * @project  Basic PWM control LED & Buzzer 
 * @author   Edward Ahn, Jim Jun
 * @version  V1.0.1
 * @date     26-MAY-2016
 * @brief    Digital Pin Control
*******************************************************************************
**/

// Buzzer PWM Define
// 도가 261Hz의 주파수를 가진다면, 1초에 261번의 square-wave을 발생신킨다는 의미입니다.
//               도    레   미   파    솔   라   시   도
//int tones[] = {261, 294, 330, 349, 392, 440, 494, 523}; // Hz
//int numTones = 8; // count
int tones[] = {261, 294, 330, 349};
int numTones = 4;

const int SW = 2;           // LED Control SW 선언 D2
const int ledPin =  13;     // LED 핀 선언 D13
const int buzzerPin = 5;    // Buzzer 핀 선언 D5

void setup() {
  pinMode(SW, INPUT); // LED SW 입력설정
  pinMode(ledPin, OUTPUT); // LED 출력설정
  pinMode(buzzerPin, OUTPUT); // Buzzer 출력설정
}

void loop(){
  int i;
  
  // LED PWM Test
  if(digitalRead(SW) == LOW) // 스위치가 'ON' 되면
  {
    for(i = 0; i < 255; i++)
    {
      /*LED를 아날로그출력으로 0 ~ 255까지 값을 순서대로 출력한다.
        1, 2, 3.. 값이 올라갈 수록 밝기가 밝아진다.*/
      analogWrite(ledPin, i);
      delay(20);
    }
    for(i = 255; i > 0; i--)
    {
      analogWrite(ledPin, i);
      delay(20);
    }

    for( i = 0; i < numTones; i++) // numTones의 크기만큼 동작
    {
      tone(buzzerPin, tones[i]); // 50% 듀디 사이클을 출력하는 함수
      delay(500); // 0.5s
    }
    analogWrite(buzzerPin, 0);
  }
}
